SystemOrganization addCategory: #HashProof!
SystemOrganization addCategory: 'HashProof-Example'!

Trait named: #CoreHashProofTrait
	uses: {}
	category: 'HashProof'!

Trait named: #ClassCheckingHashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

ClassCheckingHashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

Trait named: #ChangeAnnouncingClassCheckingHashProofTrait
	uses: ClassCheckingHashProofTrait
	category: 'HashProof'!

ChangeAnnouncingClassCheckingHashProofTrait classTrait
	uses: ClassCheckingHashProofTrait classTrait!

!ChangeAnnouncingClassCheckingHashProofTrait methodsFor: 'announce' stamp: 'HwaJong 3/5/2014 14:31'!
announceHashHasChanged
	
	self announcer ifNotNil: [: that | that announce: (ElementOfHashedCollectionChanged new element: self) ]! !

!ClassCheckingHashProofTrait methodsFor: 'comparing' stamp: 'hjo 8/11/2012 21:16'!
= anObject
	self == anObject ifTrue: [^true].
	self class ~= anObject class ifTrue: [^false].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!CoreHashProofTrait methodsFor: 'comparing' stamp: 'HwaJong 11/7/2012 22:03'!
hash

	^self gettersForEquality inject: 0 into: [:hash :symbol| (hash fastBitShift7 hash) bitXor: (self perform: symbol) hash]! !

!CoreHashProofTrait methodsFor: 'comparing' stamp: 'HwaJong 5/3/2014 18:53'!
subHashes

	^self gettersForEquality collect: [:symbol| (self perform: symbol) hash]! !

Trait named: #HashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

HashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

!HashProofTrait methodsFor: 'comparing' stamp: 'hjo 7/8/2012 13:37'!
= anObject
	self == anObject ifTrue: [^true].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

!HashProofTrait methodsFor: 'comparing' stamp: 'HwaJong 3/5/2014 14:45'!
gettersForEquality
	"answer an array of getters for equality testing.
	^{#field. #field2} "
	^self explicitRequirement.! !

Trait named: #ProtocolCheckingHashProofTrait
	uses: CoreHashProofTrait
	category: 'HashProof'!

ProtocolCheckingHashProofTrait classTrait
	uses: CoreHashProofTrait classTrait!

!ProtocolCheckingHashProofTrait methodsFor: 'comparing' stamp: 'hjo 8/11/2012 18:51'!
= anObject
	self == anObject ifTrue: [^true].
	(self gettersForEquality allSatisfy: [:symbol| anObject respondsTo: symbol]) ifFalse: [^false].
	^self gettersForEquality allSatisfy: [:symbol| (self perform: symbol) = (anObject perform: symbol) ]
	! !

Announcement subclass: #ElementOfHashedCollectionChanged
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof'!

!ElementOfHashedCollectionChanged methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 15:40'!
element
	^element! !

!ElementOfHashedCollectionChanged methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:08'!
element: anObject 
	element := anObject ! !

TestCase subclass: #HashProofAnnouncingCollectionOwnerTest
	instanceVariableNames: 'collectionOwner a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof-Example'!

!HashProofAnnouncingCollectionOwnerTest methodsFor: 'running' stamp: 'HwaJong 3/5/2014 15:20'!
setUp

	super setUp.
	
	a := HashProofAnnouncingObjectExample new
		index: 2;
		card: 'BC';
		ship: 'clark'.
	b := HashProofAnnouncingObjectExample new
		index: 4;
		card: 'Master';
		ship: 'maria'.
	c := HashProofAnnouncingObjectExample new
		index: 3;
		card: 'VISA';
		ship: 'tasha'.

	collectionOwner := HashProofCollectionOwnerExample new.
	collectionOwner add: a.
	collectionOwner add: b.
	collectionOwner add: c.
! !

!HashProofAnnouncingCollectionOwnerTest methodsFor: 'tests' stamp: 'HwaJong 3/5/2014 15:20'!
testCardDictionary
	b card: 'pirate'.
	self assert: (collectionOwner cardDictionary at: 'pirate') == b.! !

!HashProofAnnouncingCollectionOwnerTest methodsFor: 'tests' stamp: 'HwaJong 3/5/2014 15:18'!
testIndexDictionary
	a index: 100.
	b card: 'pirate'.
	c ship: 'smith'.
	self assert: (collectionOwner indexDictionary at: 100) == a.! !

!HashProofAnnouncingCollectionOwnerTest methodsFor: 'tests' stamp: 'HwaJong 3/5/2014 15:09'!
testSet
	a index: 100.
	b card: 'pirate'.
	c ship: 'smith'.
	self assert: (collectionOwner set includes: a).
	self assert: (collectionOwner set includes: b).
	self assert: (collectionOwner set includes: c)! !

!HashProofAnnouncingCollectionOwnerTest methodsFor: 'running' stamp: 'HwaJong 3/5/2014 15:09'!
testSetUp
	self assert: (collectionOwner set includes: a).
	self assert: (collectionOwner set includes: b).
	self assert: (collectionOwner set includes: c).
! !

!Integer methodsFor: '*HashProof' stamp: 'HwaJong 5/1/2013 12:22'!
fastBitShift7
^((self bitAnd: 2r000000011111111111111111111111) * 2r10000000) + ((self bitAnd: 2r111111100000000000000000000000) //  2r100000000000000000000000).! !

Object subclass: #HashProofAnnouncingObjectExample
	uses: ChangeAnnouncingClassCheckingHashProofTrait
	instanceVariableNames: 'index card ship announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof-Example'!

HashProofAnnouncingObjectExample class
	uses: ChangeAnnouncingClassCheckingHashProofTrait classTrait
	instanceVariableNames: ''!

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:32'!
announcer
	^announcer! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:04'!
announcer: anAnnouncer 
	announcer := anAnnouncer ! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 13:54'!
card
	^ card! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:18'!
card: aString 
	card := aString.
	self announceHashHasChanged! !

!HashProofAnnouncingObjectExample methodsFor: 'comparing' stamp: 'HwaJong 3/5/2014 13:54'!
gettersForEquality
	^{#index. #card. #ship}! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 13:54'!
index
	^ index! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:18'!
index: anInteger 
	index := anInteger.
	self announceHashHasChanged! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 13:54'!
ship
	^ ship! !

!HashProofAnnouncingObjectExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:18'!
ship: aString 
	ship := aString.
	self announceHashHasChanged! !

Object subclass: #HashProofCollectionOwnerExample
	instanceVariableNames: 'set announcer indexDictionary cardDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof-Example'!

!HashProofCollectionOwnerExample methodsFor: 'adding' stamp: 'HwaJong 3/5/2014 15:19'!
add: anObject 
	anObject announcer: announcer.
	self set add: anObject.
	self indexDictionary at: anObject index put: anObject.
	self cardDictionary at: anObject card put: anObject.! !

!HashProofCollectionOwnerExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 14:03'!
announcer
	^ announcer! !

!HashProofCollectionOwnerExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 15:19'!
cardDictionary
	^ cardDictionary! !

!HashProofCollectionOwnerExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 15:07'!
indexDictionary
	^ indexDictionary! !

!HashProofCollectionOwnerExample methodsFor: 'initialization' stamp: 'HwaJong 3/5/2014 15:19'!
initialize
	super initialize.
	announcer := Announcer new.
	set := Set new.
	indexDictionary := Dictionary new.
	cardDictionary := Dictionary new.
	
	announcer on: ElementOfHashedCollectionChanged do: 
		[ :ann|
		set rehash.
		indexDictionary := Dictionary newFrom: (indexDictionary values collect: [:object| object index -> object ]).
		cardDictionary := Dictionary newFrom: (indexDictionary values collect: [:object| object card -> object ]).]! !

!HashProofCollectionOwnerExample methodsFor: 'accessing' stamp: 'HwaJong 3/5/2014 13:52'!
set
	^ set! !

Object subclass: #HashProofUseExample
	uses: HashProofTrait
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HashProof-Example'!

HashProofUseExample class
	uses: HashProofTrait classTrait
	instanceVariableNames: ''!

!HashProofUseExample methodsFor: 'comparing' stamp: 'hjo 9/13/2011 17:55'!
gettersForEquality

	^{#x . #y. #z}! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
x
	^ x! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
x: anObject
	x := anObject! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
y
	^ y! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
y: anObject
	y := anObject! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
z
	^ z! !

!HashProofUseExample methodsFor: 'accessing' stamp: 'hjo 9/13/2011 17:51'!
z: anObject
	z := anObject! !
